MODULE Controls;

IMPORT
  SYSTEM, Trace, W := Windows, U := Utilites, Cl := Classes, M := Menus;

TYPE
  Byte         = W.Byte;
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Control* = OBJECT (Cl.Wincontrol)
  VAR
    popup* : M.Popupmenu;

    PROCEDURE & Create*(Parent: Control);
    BEGIN
      Initctl^(Parent);
      name      := "Control";
      classname := "Control";
    END Create;

    PROCEDURE MouseDown*(shift: Set; button,x,y: Longint);
    BEGIN
      MouseDown^(shift,button,x,y);
      IF (button = Cl.mbRight) THEN
        IF (popup # NIL) THEN popup.Popup(-1,-1) ELSE PopupHide(NIL) END;
      END;
    END MouseDown;

  END Control;

  Customcontrol* = OBJECT (Cl.Customcontrol)

    PROCEDURE & Create*(Parent: Control);
    BEGIN
      InitControl^(Parent);
    END Create;

  END Customcontrol;

END Controls.
