MODULE Assistants;

IMPORT
  SYSTEM, W := Windows, Cl := Classes, G := Graphics;

TYPE
  Byte         = W.Byte;
  Char         = W.Char;
  Boolean      = W.Boolean;
  Shortint     = W.Shortint;
  Integer      = W.Integer;
  Longint      = W.Longint;
  Real         = W.Real;
  Longreal     = W.Longreal;
  Pointer      = W.Pointer;
  Set	       = W.Set;
  String       = W.String;
  Name         = W.Name;

  Gutter* = OBJECT (Cl.Persistent)
  VAR
    color*     : Longint;
    width*     : Longint;
    linecolor* : Longint;
    lineshadow*: Longint;

    PROCEDURE & Init*;
    BEGIN
      Init^;
      name      := "Gutter";
      color     := G.clWhite;
      width     := 32;
      linecolor := G.clMedGray;
      lineshadow:= G.clWhite;
      property.AddString ("name",name);
      property.AddLongint("color",color);
      property.AddLongint("linecolor",linecolor);
      property.AddLongint("lineshadow",lineshadow);
      property.AddLongint("width",width);
      property.Sort;
    END Init;

    PROCEDURE Update*;
    BEGIN
      property.AddLongint("color",color);
      property.AddLongint("linecolor",linecolor);
      property.AddLongint("lineshadow",lineshadow);
      property.AddLongint("width",width);
    END Update;

  END Gutter;

END Assistants.
